<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Novel List</title>

  <!-- Bootstrap CSS -->
  <link rel="stylesheet" href="/bootstrap/4.0.0-beta.2/css/bootstrap.min.css">
</head>


<body>
  <script id="list-template" type="text/x-handlebars-template">
      <h3>Novel List</h3>    
        <table class="table table-striped">
          <thead class="thead-light">
            <tr>
              <th scope="col">#</th>
              <th scope="col">Name</th>
              <th scope="col">Type</th>
              <th scope="col">Action</th>
            </tr>
          </thead>
          <tbody id="novel-list">
            {{#each novels}}
            <tr>
              <th scope="row">{{id}}</th>
              <td>{{name}}</td>
              <td>{{type}}</td>
              <td>
                <a href="/view/{{id}}">View</a>
                <a href="#" onclick="editNovel({{id}})">Edit</a>
                <a href="#" onclick="deleteNovel({{id}})">Delete</a>
              </td>
            </tr>
            {{/each}}
          </tbody>
        </table>
  </script>

  <script id="edit-template" type="text/x-handlebars-template">
    <form>
        <div class="form-group">
            <label>Book Name</label>
            <input class="form-control" type="text" id="bookName" value="{{name}}">
        </div>

        <div class="form-group">
            <label for="bookType">Book Type</label>
            <select class="form-control" id="bookType">
              <option value="1">1</option>
              <option value="2">2</option>
              <option value="3">3</option>
              <option value="4">4</option>
              <option value="5">5</option>
            </select>
          </div>

        <div class="form-group">
            <label>Book Content</label>
            <textarea class="form-control" id="bookContent" rows="10">{{content}}</textarea>
        </div>

        <button class="btn btn-primary" id="bookUpdate" onclick="updateNovel({{id}})">Submit</button>

    </form>


  </script>

  <script id="detail-template" type="text/x-handlebars-template">
          <h4>{{name}}</h4>
    
          <p>
            {{content}}
          </p>
          <a href="#">Link 2</a>
  </script>
  <div class="container">
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
      <a class="navbar-brand" href="/novels/list.html">Home</a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"
        aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>

      <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav mr-auto">
          <li class="nav-item active">
            <a class="nav-link" href="/novels/list.html">Home
              <span class="sr-only">(current)</span>
            </a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="/novels/add.html">Add Novel</a>
          </li>
        </ul>
      </div>
    </nav>
  </div>


  <div class="container" id="novel">

  </div>



  <script src="/handlebarsjs/4.0.11/handlebars.js"></script>
  <script src="/jquery-3.3.1.min.js"></script>

  <script>

    function listNovel() {
      var source = document.getElementById("list-template").innerHTML;
      var template = Handlebars.compile(source);

      $.get("/api/novel", function (data, status) {

        console.log(data);

        var html = template({ novels: data });
        $('#novel').html(html);
      });
    }

    listNovel();

    function deleteNovel(id) {
      console.log('delete novel', id);

      $.ajax({
        url: '/api/novel/' + id,
        method: 'DELETE',
        contentType: 'application/json',
        success: function (result) {
          alert('delete success', id);
          window.location = 'list.html';
        },
        error: function (request, msg, error) {
          // handle failure
          alert('delete failure', id);
        }
      });
    }

    function viewNovel(id) {
      console.log('view novel', id);
      var source = document.getElementById("detail-template").innerHTML;
      var template = Handlebars.compile(source);

      $.get("/api/novel/" + id, function (data, status) {
        console.log(data);

        var html = template(data);
        $('#novel').html(html);

      });
    }


    function editNovel(id) {
      console.log('edit novel', id);
      var source = document.getElementById("edit-template").innerHTML;
      var template = Handlebars.compile(source);

      $.get("/api/novel/" + id, function (data, status) {
        console.log(data);
        var html = template(data);
        $('#novel').html(html);

        $('#bookType').val(data.type);
      });
    }

    function updateNovel(id) {

      let bookName = $('#bookName').val();
      let bookType = $('#bookType').val();
      let bookContent = $('#bookContent').val();

      console.log(bookName, bookType, bookContent);
      var novel = {
        name: bookName,
        type: bookType,
        content: bookContent
      }
      $.ajax({
        url: '/api/novel/' + id,
        type: 'PUT',
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify(novel),
        success: function (data) {
          alert("update success: ");
          window.location = 'list.html';
        }

      });
    }

  </script>
</body>


</html>